diff --git a/src/backend/parser/parse_target.c b/src/backend/parser/parse_target.c
index 2a1d44b813..cff1cda48d 100644
--- a/src/backend/parser/parse_target.c
+++ b/src/backend/parser/parse_target.c
@@ -347,31 +347,31 @@ markTargetListOrigin(ParseState *pstate, TargetEntry *tle,
 {
 	int			netlevelsup;
 	RangeTblEntry *rte;
-	AttrNumber	attnum;
+	AttrNumber	attphysnum;
 
 	if (var == NULL || !IsA(var, Var))
 		return;
 	netlevelsup = var->varlevelsup + levelsup;
 	rte = GetRTEByRangeTablePosn(pstate, var->varno, netlevelsup);
-	attnum = var->varattno;
+	attphysnum = var->varattno;
 
 	switch (rte->rtekind)
 	{
 		case RTE_RELATION:
 			/* It's a table or view, report it */
 			tle->resorigtbl = rte->relid;
-			tle->resorigcol = attnum;
+			tle->resorigcol = attphysnum;
 			break;
 		case RTE_SUBQUERY:
 			/* Subselect-in-FROM: copy up from the subselect */
-			if (attnum != InvalidAttrNumber)
+			if (attphysnum != InvalidAttrNumber)
 			{
 				TargetEntry *ste = get_tle_by_resno(rte->subquery->targetList,
-													attnum);
+													attphysnum);
 
 				if (ste == NULL || ste->resjunk)
 					elog(ERROR, "subquery %s does not have attribute %d",
-						 rte->eref->aliasname, attnum);
+						 rte->eref->aliasname, attphysnum);
 				tle->resorigtbl = ste->resorigtbl;
 				tle->resorigcol = ste->resorigcol;
 			}
@@ -394,7 +394,7 @@ markTargetListOrigin(ParseState *pstate, TargetEntry *tle,
 			 * recursive CTE, and so any markings on the current targetlist
 			 * are not going to affect the results anyway.
 			 */
-			if (attnum != InvalidAttrNumber && !rte->self_reference)
+			if (attphysnum != InvalidAttrNumber && !rte->self_reference)
 			{
 				CommonTableExpr *cte = GetCTEForRTE(pstate, rte, netlevelsup);
 				TargetEntry *ste;
@@ -410,14 +410,14 @@ markTargetListOrigin(ParseState *pstate, TargetEntry *tle,
 				if (cte->cycle_clause)
 					extra_cols += 2;
 				if (extra_cols &&
-					attnum > list_length(tl) &&
-					attnum <= list_length(tl) + extra_cols)
+					attphysnum > list_length(tl) &&
+					attphysnum <= list_length(tl) + extra_cols)
 					break;
 
-				ste = get_tle_by_resno(tl, attnum);
+				ste = get_tle_by_resno(tl, attphysnum);
 				if (ste == NULL || ste->resjunk)
 					elog(ERROR, "CTE %s does not have attribute %d",
-						 rte->eref->aliasname, attnum);
+						 rte->eref->aliasname, attphysnum);
 				tle->resorigtbl = ste->resorigtbl;
 				tle->resorigcol = ste->resorigcol;
 			}
@@ -745,7 +745,7 @@ transformAssignmentIndirection(ParseState *pstate,
 			Oid			baseTypeId;
 			int32		baseTypeMod;
 			Oid			typrelid;
-			AttrNumber	attnum;
+			AttrNumber	attphysnum;
 			Oid			fieldTypeId;
 			int32		fieldTypMod;
 			Oid			fieldCollation;
@@ -789,22 +789,22 @@ transformAssignmentIndirection(ParseState *pstate,
 								format_type_be(targetTypeId)),
 						 parser_errposition(pstate, location)));
 
-			attnum = get_attnum(typrelid, strVal(n));
-			if (attnum == InvalidAttrNumber)
+			attphysnum = get_attphysnum(typrelid, strVal(n));
+			if (attphysnum == InvalidAttrNumber)
 				ereport(ERROR,
 						(errcode(ERRCODE_UNDEFINED_COLUMN),
 						 errmsg("cannot assign to field \"%s\" of column \"%s\" because there is no such column in data type %s",
 								strVal(n), targetName,
 								format_type_be(targetTypeId)),
 						 parser_errposition(pstate, location)));
-			if (attnum < 0)
+			if (attphysnum < 0)
 				ereport(ERROR,
 						(errcode(ERRCODE_UNDEFINED_COLUMN),
 						 errmsg("cannot assign to system column \"%s\"",
 								strVal(n)),
 						 parser_errposition(pstate, location)));
 
-			get_atttypetypmodcoll(typrelid, attnum,
+			get_atttypetypmodcoll(typrelid, attphysnum,
 								  &fieldTypeId, &fieldTypMod, &fieldCollation);
 
 			/* recurse to create appropriate RHS for field assign */
@@ -825,7 +825,7 @@ transformAssignmentIndirection(ParseState *pstate,
 			fstore = makeNode(FieldStore);
 			fstore->arg = (Expr *) basenode;
 			fstore->newvals = list_make1(rhs);
-			fstore->fieldnums = list_make1_int(attnum);
+			fstore->fieldnums = list_make1_int(attphysnum);
 			fstore->resulttype = baseTypeId;
 
 			/* If target is a domain, apply constraints */
@@ -1512,7 +1512,7 @@ expandRecordVariable(ParseState *pstate, Var *var, int levelsup)
 	TupleDesc	tupleDesc;
 	int			netlevelsup;
 	RangeTblEntry *rte;
-	AttrNumber	attnum;
+	AttrNumber	attphysnum;
 	Node	   *expr;
 
 	/* Check my caller didn't mess up */
@@ -1527,9 +1527,9 @@ expandRecordVariable(ParseState *pstate, Var *var, int levelsup)
 	 */
 	netlevelsup = var->varlevelsup + levelsup;
 	rte = GetRTEByRangeTablePosn(pstate, var->varno, netlevelsup);
-	attnum = var->varattno;
+	attphysnum = var->varattno;
 
-	if (attnum == InvalidAttrNumber)
+	if (attphysnum == InvalidAttrNumber)
 	{
 		/* Whole-row reference to an RTE, so expand the known fields */
 		List	   *names,
@@ -1581,11 +1581,11 @@ expandRecordVariable(ParseState *pstate, Var *var, int levelsup)
 			{
 				/* Subselect-in-FROM: examine sub-select's output expr */
 				TargetEntry *ste = get_tle_by_resno(rte->subquery->targetList,
-													attnum);
+													attphysnum);
 
 				if (ste == NULL || ste->resjunk)
 					elog(ERROR, "subquery %s does not have attribute %d",
-						 rte->eref->aliasname, attnum);
+						 rte->eref->aliasname, attphysnum);
 				expr = (Node *) ste->expr;
 				if (IsA(expr, Var))
 				{
@@ -1608,8 +1608,8 @@ expandRecordVariable(ParseState *pstate, Var *var, int levelsup)
 			break;
 		case RTE_JOIN:
 			/* Join RTE --- recursively inspect the alias variable */
-			Assert(attnum > 0 && attnum <= list_length(rte->joinaliasvars));
-			expr = (Node *) list_nth(rte->joinaliasvars, attnum - 1);
+			Assert(attphysnum > 0 && attphysnum <= list_length(rte->joinaliasvars));
+			expr = (Node *) list_nth(rte->joinaliasvars, attphysnum - 1);
 			Assert(expr != NULL);
 			/* We intentionally don't strip implicit coercions here */
 			if (IsA(expr, Var))
@@ -1636,10 +1636,10 @@ expandRecordVariable(ParseState *pstate, Var *var, int levelsup)
 				CommonTableExpr *cte = GetCTEForRTE(pstate, rte, netlevelsup);
 				TargetEntry *ste;
 
-				ste = get_tle_by_resno(GetCTETargetList(cte), attnum);
+				ste = get_tle_by_resno(GetCTETargetList(cte), attphysnum);
 				if (ste == NULL || ste->resjunk)
 					elog(ERROR, "CTE %s does not have attribute %d",
-						 rte->eref->aliasname, attnum);
+						 rte->eref->aliasname, attphysnum);
 				expr = (Node *) ste->expr;
 				if (IsA(expr, Var))
 				{
diff --git a/src/backend/parser/parse_type.c b/src/backend/parser/parse_type.c
index 307114a30d..1959ef3bc1 100644
--- a/src/backend/parser/parse_type.c
+++ b/src/backend/parser/parse_type.c
@@ -89,7 +89,7 @@ LookupTypeNameExtended(ParseState *pstate,
 		RangeVar   *rel = makeRangeVar(NULL, NULL, typeName->location);
 		char	   *field = NULL;
 		Oid			relid;
-		AttrNumber	attnum;
+		AttrNumber	attphysnum;
 
 		/* deconstruct the name list */
 		switch (list_length(typeName->names))
@@ -133,8 +133,8 @@ LookupTypeNameExtended(ParseState *pstate,
 		 * penalty and would also require a permissions check.
 		 */
 		relid = RangeVarGetRelid(rel, NoLock, missing_ok);
-		attnum = get_attnum(relid, field);
-		if (attnum == InvalidAttrNumber)
+		attphysnum = get_attphysnum(relid, field);
+		if (attphysnum == InvalidAttrNumber)
 		{
 			if (missing_ok)
 				typoid = InvalidOid;
@@ -147,7 +147,7 @@ LookupTypeNameExtended(ParseState *pstate,
 		}
 		else
 		{
-			typoid = get_atttype(relid, attnum);
+			typoid = get_atttype(relid, attphysnum);
 
 			/* this construct should never have an array indicator */
 			Assert(typeName->arrayBounds == NIL);
diff --git a/src/backend/parser/parse_utilcmd.c b/src/backend/parser/parse_utilcmd.c
index 1a64a52279..69132f729d 100644
--- a/src/backend/parser/parse_utilcmd.c
+++ b/src/backend/parser/parse_utilcmd.c
@@ -487,7 +487,7 @@ generateSerialExtraStmts(CreateStmtContext *cxt, ColumnDef *column,
 	 * owned by this column, and add it to the appropriate list of things to
 	 * be done along with this CREATE/ALTER TABLE.  In a CREATE or ALTER ADD
 	 * COLUMN, it must be done after the statement because we don't know the
-	 * column's attnum yet.  But if we do have the attnum (in AT_AddIdentity),
+	 * column's attphysnum yet.  But if we do have the attphysnum (in AT_AddIdentity),
 	 * we can do the marking immediately, which improves some ALTER TABLE
 	 * behaviors.
 	 */
@@ -1070,7 +1070,7 @@ transformTableLikeClause(CreateStmtContext *cxt, TableLikeClause *table_like_cla
 			 * find sequence owned by old column; extract sequence parameters;
 			 * build new create sequence command
 			 */
-			seq_relid = getIdentitySequence(RelationGetRelid(relation), attribute->attnum, false);
+			seq_relid = getIdentitySequence(RelationGetRelid(relation), attribute->attphysnum, false);
 			seq_options = sequence_options(seq_relid);
 			generateSerialExtraStmts(cxt, def,
 									 InvalidOid, seq_options,
@@ -1097,7 +1097,7 @@ transformTableLikeClause(CreateStmtContext *cxt, TableLikeClause *table_like_cla
 		if ((table_like_clause->options & CREATE_TABLE_LIKE_COMMENTS) &&
 			(comment = GetComment(attribute->attrelid,
 								  RelationRelationId,
-								  attribute->attnum)) != NULL)
+								  attribute->attphysnum)) != NULL)
 		{
 			CommentStmt *stmt = makeNode(CommentStmt);
 
@@ -1701,20 +1701,20 @@ generateClonedIndexStmt(RangeVar *heapRel, Relation source_idx,
 	for (keyno = 0; keyno < idxrec->indnkeyatts; keyno++)
 	{
 		IndexElem  *iparam;
-		AttrNumber	attnum = idxrec->indkey.values[keyno];
+		AttrNumber	attphysnum = idxrec->indkey.values[keyno];
 		Form_pg_attribute attr = TupleDescAttr(RelationGetDescr(source_idx),
 											   keyno);
 		int16		opt = source_idx->rd_indoption[keyno];
 
 		iparam = makeNode(IndexElem);
 
-		if (AttributeNumberIsValid(attnum))
+		if (AttributeNumberIsValid(attphysnum))
 		{
 			/* Simple index column */
 			char	   *attname;
 
-			attname = get_attname(indrelid, attnum, false);
-			keycoltype = get_atttype(indrelid, attnum);
+			attname = get_attname(indrelid, attphysnum, false);
+			keycoltype = get_atttype(indrelid, attphysnum);
 
 			iparam->name = attname;
 			iparam->expr = NULL;
@@ -1793,18 +1793,18 @@ generateClonedIndexStmt(RangeVar *heapRel, Relation source_idx,
 	for (keyno = idxrec->indnkeyatts; keyno < idxrec->indnatts; keyno++)
 	{
 		IndexElem  *iparam;
-		AttrNumber	attnum = idxrec->indkey.values[keyno];
+		AttrNumber	attphysnum = idxrec->indkey.values[keyno];
 		Form_pg_attribute attr = TupleDescAttr(RelationGetDescr(source_idx),
 											   keyno);
 
 		iparam = makeNode(IndexElem);
 
-		if (AttributeNumberIsValid(attnum))
+		if (AttributeNumberIsValid(attphysnum))
 		{
 			/* Simple index column */
 			char	   *attname;
 
-			attname = get_attname(indrelid, attnum, false);
+			attname = get_attname(indrelid, attphysnum, false);
 
 			iparam->name = attname;
 			iparam->expr = NULL;
@@ -1922,9 +1922,9 @@ generateClonedExtStatsStmt(RangeVar *heapRel, Oid heapRelid,
 	for (i = 0; i < statsrec->stxkeys.dim1; i++)
 	{
 		StatsElem  *selem = makeNode(StatsElem);
-		AttrNumber	attnum = statsrec->stxkeys.values[i];
+		AttrNumber	attphysnum = statsrec->stxkeys.values[i];
 
-		selem->name = get_attname(heapRelid, attnum, false);
+		selem->name = get_attname(heapRelid, attphysnum, false);
 		selem->expr = NULL;
 
 		def_names = lappend(def_names, selem);
@@ -2330,23 +2330,23 @@ transformIndexConstraint(Constraint *constraint, CreateStmtContext *cxt)
 
 		for (i = 0; i < index_form->indnatts; i++)
 		{
-			int16		attnum = index_form->indkey.values[i];
+			int16		attphysnum = index_form->indkey.values[i];
 			const FormData_pg_attribute *attform;
 			char	   *attname;
 			Oid			defopclass;
 
 			/*
-			 * We shouldn't see attnum == 0 here, since we already rejected
+			 * We shouldn't see attphysnum == 0 here, since we already rejected
 			 * expression indexes.  If we do, SystemAttributeDefinition will
 			 * throw an error.
 			 */
-			if (attnum > 0)
+			if (attphysnum > 0)
 			{
-				Assert(attnum <= heap_rel->rd_att->natts);
-				attform = TupleDescAttr(heap_rel->rd_att, attnum - 1);
+				Assert(attphysnum <= heap_rel->rd_att->natts);
+				attform = TupleDescAttr(heap_rel->rd_att, attphysnum - 1);
 			}
 			else
-				attform = SystemAttributeDefinition(attnum);
+				attform = SystemAttributeDefinition(attphysnum);
 			attname = pstrdup(NameStr(attform->attname));
 
 			if (i < index_form->indnkeyatts)
@@ -3400,7 +3400,7 @@ transformAlterTableStmt(Oid relid, AlterTableStmt *stmt,
 			case AT_AlterColumnType:
 				{
 					ColumnDef  *def = castNode(ColumnDef, cmd->def);
-					AttrNumber	attnum;
+					AttrNumber	attphysnum;
 
 					/*
 					 * For ALTER COLUMN TYPE, transform the USING clause if
@@ -3417,17 +3417,17 @@ transformAlterTableStmt(Oid relid, AlterTableStmt *stmt,
 					 * For identity column, create ALTER SEQUENCE command to
 					 * change the data type of the sequence.
 					 */
-					attnum = get_attnum(relid, cmd->name);
-					if (attnum == InvalidAttrNumber)
+					attphysnum = get_attphysnum(relid, cmd->name);
+					if (attphysnum == InvalidAttrNumber)
 						ereport(ERROR,
 								(errcode(ERRCODE_UNDEFINED_COLUMN),
 								 errmsg("column \"%s\" of relation \"%s\" does not exist",
 										cmd->name, RelationGetRelationName(rel))));
 
-					if (attnum > 0 &&
-						TupleDescAttr(tupdesc, attnum - 1)->attidentity)
+					if (attphysnum > 0 &&
+						TupleDescAttr(tupdesc, attphysnum - 1)->attidentity)
 					{
-						Oid			seq_relid = getIdentitySequence(relid, attnum, false);
+						Oid			seq_relid = getIdentitySequence(relid, attphysnum, false);
 						Oid			typeOid = typenameTypeId(pstate, def->typeName);
 						AlterSeqStmt *altseqstmt = makeNode(AlterSeqStmt);
 
@@ -3447,21 +3447,21 @@ transformAlterTableStmt(Oid relid, AlterTableStmt *stmt,
 				{
 					Constraint *def = castNode(Constraint, cmd->def);
 					ColumnDef  *newdef = makeNode(ColumnDef);
-					AttrNumber	attnum;
+					AttrNumber	attphysnum;
 
 					newdef->colname = cmd->name;
 					newdef->identity = def->generated_when;
 					cmd->def = (Node *) newdef;
 
-					attnum = get_attnum(relid, cmd->name);
-					if (attnum == InvalidAttrNumber)
+					attphysnum = get_attphysnum(relid, cmd->name);
+					if (attphysnum == InvalidAttrNumber)
 						ereport(ERROR,
 								(errcode(ERRCODE_UNDEFINED_COLUMN),
 								 errmsg("column \"%s\" of relation \"%s\" does not exist",
 										cmd->name, RelationGetRelationName(rel))));
 
 					generateSerialExtraStmts(&cxt, newdef,
-											 get_atttype(relid, attnum),
+											 get_atttype(relid, attphysnum),
 											 def->options, true, true,
 											 NULL, NULL);
 
@@ -3478,7 +3478,7 @@ transformAlterTableStmt(Oid relid, AlterTableStmt *stmt,
 					ListCell   *lc;
 					List	   *newseqopts = NIL;
 					List	   *newdef = NIL;
-					AttrNumber	attnum;
+					AttrNumber	attphysnum;
 					Oid			seq_relid;
 
 					/*
@@ -3495,14 +3495,14 @@ transformAlterTableStmt(Oid relid, AlterTableStmt *stmt,
 							newseqopts = lappend(newseqopts, def);
 					}
 
-					attnum = get_attnum(relid, cmd->name);
-					if (attnum == InvalidAttrNumber)
+					attphysnum = get_attphysnum(relid, cmd->name);
+					if (attphysnum == InvalidAttrNumber)
 						ereport(ERROR,
 								(errcode(ERRCODE_UNDEFINED_COLUMN),
 								 errmsg("column \"%s\" of relation \"%s\" does not exist",
 										cmd->name, RelationGetRelationName(rel))));
 
-					seq_relid = getIdentitySequence(relid, attnum, true);
+					seq_relid = getIdentitySequence(relid, attphysnum, true);
 
 					if (seq_relid)
 					{
diff --git a/src/backend/replication/basebackup_copy.c b/src/backend/replication/basebackup_copy.c
index cabb077240..38d792884e 100644
--- a/src/backend/replication/basebackup_copy.c
+++ b/src/backend/replication/basebackup_copy.c
@@ -346,7 +346,7 @@ SendXlogRecPtrResult(XLogRecPtr ptr, TimeLineID tli)
 	/* Field headers */
 	pq_sendstring(&buf, "recptr");
 	pq_sendint32(&buf, 0);		/* table oid */
-	pq_sendint16(&buf, 0);		/* attnum */
+	pq_sendint16(&buf, 0);		/* attphysnum */
 	pq_sendint32(&buf, TEXTOID);	/* type oid */
 	pq_sendint16(&buf, -1);
 	pq_sendint32(&buf, 0);
@@ -354,7 +354,7 @@ SendXlogRecPtrResult(XLogRecPtr ptr, TimeLineID tli)
 
 	pq_sendstring(&buf, "tli");
 	pq_sendint32(&buf, 0);		/* table oid */
-	pq_sendint16(&buf, 0);		/* attnum */
+	pq_sendint16(&buf, 0);		/* attphysnum */
 
 	/*
 	 * int8 may seem like a surprising data type for this, but in theory int4
@@ -401,7 +401,7 @@ SendTablespaceList(List *tablespaces)
 	/* First field - spcoid */
 	pq_sendstring(&buf, "spcoid");
 	pq_sendint32(&buf, 0);		/* table oid */
-	pq_sendint16(&buf, 0);		/* attnum */
+	pq_sendint16(&buf, 0);		/* attphysnum */
 	pq_sendint32(&buf, OIDOID); /* type oid */
 	pq_sendint16(&buf, 4);		/* typlen */
 	pq_sendint32(&buf, 0);		/* typmod */
diff --git a/src/backend/replication/logical/proto.c b/src/backend/replication/logical/proto.c
index ff8513e2d2..0e68aa0d9d 100644
--- a/src/backend/replication/logical/proto.c
+++ b/src/backend/replication/logical/proto.c
@@ -47,9 +47,9 @@ static const char *logicalrep_read_namespace(StringInfo in);
  * all columns.
  */
 static bool
-column_in_column_list(int attnum, Bitmapset *columns)
+column_in_column_list(int attphysnum, Bitmapset *columns)
 {
-	return (columns == NULL || bms_is_member(attnum, columns));
+	return (columns == NULL || bms_is_member(attphysnum, columns));
 }
 
 
@@ -783,7 +783,7 @@ logicalrep_write_tuple(StringInfo out, Relation rel, TupleTableSlot *slot,
 		if (att->attisdropped || att->attgenerated)
 			continue;
 
-		if (!column_in_column_list(att->attnum, columns))
+		if (!column_in_column_list(att->attphysnum, columns))
 			continue;
 
 		nliveatts++;
@@ -804,7 +804,7 @@ logicalrep_write_tuple(StringInfo out, Relation rel, TupleTableSlot *slot,
 		if (att->attisdropped || att->attgenerated)
 			continue;
 
-		if (!column_in_column_list(att->attnum, columns))
+		if (!column_in_column_list(att->attphysnum, columns))
 			continue;
 
 		if (isnull[i])
@@ -946,7 +946,7 @@ logicalrep_write_attrs(StringInfo out, Relation rel, Bitmapset *columns)
 		if (att->attisdropped || att->attgenerated)
 			continue;
 
-		if (!column_in_column_list(att->attnum, columns))
+		if (!column_in_column_list(att->attphysnum, columns))
 			continue;
 
 		nliveatts++;
@@ -967,12 +967,12 @@ logicalrep_write_attrs(StringInfo out, Relation rel, Bitmapset *columns)
 		if (att->attisdropped || att->attgenerated)
 			continue;
 
-		if (!column_in_column_list(att->attnum, columns))
+		if (!column_in_column_list(att->attphysnum, columns))
 			continue;
 
 		/* REPLICA IDENTITY FULL means all columns are sent as part of key. */
 		if (replidentfull ||
-			bms_is_member(att->attnum - FirstLowInvalidHeapAttributeNumber,
+			bms_is_member(att->attphysnum - FirstLowInvalidHeapAttributeNumber,
 						  idattrs))
 			flags |= LOGICALREP_IS_REPLICA_IDENTITY;
 
diff --git a/src/backend/replication/logical/relation.c b/src/backend/replication/logical/relation.c
index e989047681..a067446379 100644
--- a/src/backend/replication/logical/relation.c
+++ b/src/backend/replication/logical/relation.c
@@ -290,19 +290,19 @@ logicalrep_rel_mark_updatable(LogicalRepRelMapEntry *entry)
 	i = -1;
 	while ((i = bms_next_member(idkey, i)) >= 0)
 	{
-		int			attnum = i + FirstLowInvalidHeapAttributeNumber;
+		int			attphysnum = i + FirstLowInvalidHeapAttributeNumber;
 
-		if (!AttrNumberIsForUserDefinedAttr(attnum))
+		if (!AttrNumberIsForUserDefinedAttr(attphysnum))
 			ereport(ERROR,
 					(errcode(ERRCODE_OBJECT_NOT_IN_PREREQUISITE_STATE),
 					 errmsg("logical replication target relation \"%s.%s\" uses "
 							"system columns in REPLICA IDENTITY index",
 							remoterel->nspname, remoterel->relname)));
 
-		attnum = AttrNumberGetAttrOffset(attnum);
+		attphysnum = AttrNumberGetAttrOffset(attphysnum);
 
-		if (entry->attrmap->attnums[attnum] < 0 ||
-			!bms_is_member(entry->attrmap->attnums[attnum], remoterel->attkeys))
+		if (entry->attrmap->attnums[attphysnum] < 0 ||
+			!bms_is_member(entry->attrmap->attnums[attphysnum], remoterel->attkeys))
 		{
 			entry->updatable = false;
 			break;
@@ -410,7 +410,7 @@ logicalrep_rel_open(LogicalRepRelId remoteid, LOCKMODE lockmode)
 		missingatts = bms_add_range(NULL, 0, remoterel->natts - 1);
 		for (i = 0; i < desc->natts; i++)
 		{
-			int			attnum;
+			int			attphysnum;
 			Form_pg_attribute attr = TupleDescAttr(desc, i);
 
 			if (attr->attisdropped || attr->attgenerated)
@@ -419,12 +419,12 @@ logicalrep_rel_open(LogicalRepRelId remoteid, LOCKMODE lockmode)
 				continue;
 			}
 
-			attnum = logicalrep_rel_att_by_name(remoterel,
+			attphysnum = logicalrep_rel_att_by_name(remoterel,
 												NameStr(attr->attname));
 
-			entry->attrmap->attnums[i] = attnum;
-			if (attnum >= 0)
-				missingatts = bms_del_member(missingatts, attnum);
+			entry->attrmap->attnums[i] = attphysnum;
+			if (attphysnum >= 0)
+				missingatts = bms_del_member(missingatts, attphysnum);
 		}
 
 		logicalrep_report_missing_attrs(remoterel, missingatts);
diff --git a/src/backend/replication/logical/reorderbuffer.c b/src/backend/replication/logical/reorderbuffer.c
index 8da5f9089c..2dc47f8e02 100644
--- a/src/backend/replication/logical/reorderbuffer.c
+++ b/src/backend/replication/logical/reorderbuffer.c
@@ -4668,7 +4668,7 @@ ReorderBufferToastReplace(ReorderBuffer *rb, ReorderBufferTXN *txn,
 		Size		data_done = 0;
 
 		/* system columns aren't toasted */
-		if (attr->attnum < 0)
+		if (attr->attphysnum < 0)
 			continue;
 
 		if (attr->attisdropped)
diff --git a/src/backend/replication/logical/tablesync.c b/src/backend/replication/logical/tablesync.c
index 670c6fcada..ed527173fa 100644
--- a/src/backend/replication/logical/tablesync.c
+++ b/src/backend/replication/logical/tablesync.c
@@ -852,17 +852,17 @@ fetch_remote_table_info(char *nspname, char *relname,
 	 */
 	resetStringInfo(&cmd);
 	appendStringInfo(&cmd,
-					 "SELECT a.attnum,"
+					 "SELECT a.attphysnum,"
 					 "       a.attname,"
 					 "       a.atttypid,"
-					 "       a.attnum = ANY(i.indkey)"
+					 "       a.attphysnum = ANY(i.indkey)"
 					 "  FROM pg_catalog.pg_attribute a"
 					 "  LEFT JOIN pg_catalog.pg_index i"
 					 "       ON (i.indexrelid = pg_get_replica_identity_index(%u))"
-					 " WHERE a.attnum > 0::pg_catalog.int2"
+					 " WHERE a.attphysnum > 0::pg_catalog.int2"
 					 "   AND NOT a.attisdropped %s"
 					 "   AND a.attrelid = %u"
-					 " ORDER BY a.attnum",
+					 " ORDER BY a.attphysnum",
 					 lrel->remoteid,
 					 (walrcv_server_version(LogRepWorkerWalRcvConn) >= 120000 ?
 					  "AND a.attgenerated = ''" : ""),
@@ -890,13 +890,13 @@ fetch_remote_table_info(char *nspname, char *relname,
 	while (tuplestore_gettupleslot(res->tuplestore, true, false, slot))
 	{
 		char	   *rel_colname;
-		AttrNumber	attnum;
+		AttrNumber	attphysnum;
 
-		attnum = DatumGetInt16(slot_getattr(slot, 1, &isnull));
+		attphysnum = DatumGetInt16(slot_getattr(slot, 1, &isnull));
 		Assert(!isnull);
 
 		/* If the column is not in the column list, skip it. */
-		if (included_cols != NULL && !bms_is_member(attnum, included_cols))
+		if (included_cols != NULL && !bms_is_member(attphysnum, included_cols))
 		{
 			ExecClearTuple(slot);
 			continue;
diff --git a/src/backend/replication/logical/worker.c b/src/backend/replication/logical/worker.c
index 38e3b1c1b3..89da19e43f 100644
--- a/src/backend/replication/logical/worker.c
+++ b/src/backend/replication/logical/worker.c
@@ -562,7 +562,7 @@ slot_fill_defaults(LogicalRepRelMapEntry *rel, EState *estate,
 	TupleDesc	desc = RelationGetDescr(rel->localrel);
 	int			num_phys_attrs = desc->natts;
 	int			i;
-	int			attnum,
+	int			attphysnum,
 				num_defaults = 0;
 	int		   *defmap;
 	ExprState **defexprs;
@@ -578,17 +578,17 @@ slot_fill_defaults(LogicalRepRelMapEntry *rel, EState *estate,
 	defexprs = (ExprState **) palloc(num_phys_attrs * sizeof(ExprState *));
 
 	Assert(rel->attrmap->maplen == num_phys_attrs);
-	for (attnum = 0; attnum < num_phys_attrs; attnum++)
+	for (attphysnum = 0; attphysnum < num_phys_attrs; attphysnum++)
 	{
 		Expr	   *defexpr;
 
-		if (TupleDescAttr(desc, attnum)->attisdropped || TupleDescAttr(desc, attnum)->attgenerated)
+		if (TupleDescAttr(desc, attphysnum)->attisdropped || TupleDescAttr(desc, attphysnum)->attgenerated)
 			continue;
 
-		if (rel->attrmap->attnums[attnum] >= 0)
+		if (rel->attrmap->attnums[attphysnum] >= 0)
 			continue;
 
-		defexpr = (Expr *) build_column_default(rel->localrel, attnum + 1);
+		defexpr = (Expr *) build_column_default(rel->localrel, attphysnum + 1);
 
 		if (defexpr != NULL)
 		{
@@ -597,7 +597,7 @@ slot_fill_defaults(LogicalRepRelMapEntry *rel, EState *estate,
 
 			/* Initialize executable expression in copycontext */
 			defexprs[num_defaults] = ExecInitExpr(defexpr, NULL);
-			defmap[num_defaults] = attnum;
+			defmap[num_defaults] = attphysnum;
 			num_defaults++;
 		}
 	}
@@ -634,7 +634,7 @@ slot_store_data(TupleTableSlot *slot, LogicalRepRelMapEntry *rel,
 
 			Assert(remoteattnum < tupleData->ncols);
 
-			/* Set attnum for error callback */
+			/* Set attphysnum for error callback */
 			apply_error_callback_arg.remote_attnum = remoteattnum;
 
 			if (tupleData->colstatus[remoteattnum] == LOGICALREP_COLUMN_TEXT)
@@ -683,7 +683,7 @@ slot_store_data(TupleTableSlot *slot, LogicalRepRelMapEntry *rel,
 				slot->tts_isnull[i] = true;
 			}
 
-			/* Reset attnum for error callback */
+			/* Reset attphysnum for error callback */
 			apply_error_callback_arg.remote_attnum = -1;
 		}
 		else
@@ -749,7 +749,7 @@ slot_modify_data(TupleTableSlot *slot, TupleTableSlot *srcslot,
 		{
 			StringInfo	colvalue = &tupleData->colvalues[remoteattnum];
 
-			/* Set attnum for error callback */
+			/* Set attphysnum for error callback */
 			apply_error_callback_arg.remote_attnum = remoteattnum;
 
 			if (tupleData->colstatus[remoteattnum] == LOGICALREP_COLUMN_TEXT)
@@ -794,7 +794,7 @@ slot_modify_data(TupleTableSlot *slot, TupleTableSlot *srcslot,
 				slot->tts_isnull[i] = true;
 			}
 
-			/* Reset attnum for error callback */
+			/* Reset attphysnum for error callback */
 			apply_error_callback_arg.remote_attnum = -1;
 		}
 	}
diff --git a/src/backend/replication/pgoutput/pgoutput.c b/src/backend/replication/pgoutput/pgoutput.c
index 8deae57143..caa4b4e9e2 100644
--- a/src/backend/replication/pgoutput/pgoutput.c
+++ b/src/backend/replication/pgoutput/pgoutput.c
@@ -737,7 +737,7 @@ send_relation_and_attrs(Relation relation, TransactionId xid,
 			continue;
 
 		/* Skip this attribute if it's not present in the column list */
-		if (columns != NULL && !bms_is_member(att->attnum, columns))
+		if (columns != NULL && !bms_is_member(att->attphysnum, columns))
 			continue;
 
 		OutputPluginPrepareWrite(ctx, false);
diff --git a/src/backend/replication/walsender.c b/src/backend/replication/walsender.c
index e42671722a..6b6430f941 100644
--- a/src/backend/replication/walsender.c
+++ b/src/backend/replication/walsender.c
@@ -602,7 +602,7 @@ SendTimeLineHistory(TimeLineHistoryCmd *cmd)
 	/* first field */
 	pq_sendstring(&buf, "filename");	/* col name */
 	pq_sendint32(&buf, 0);		/* table oid */
-	pq_sendint16(&buf, 0);		/* attnum */
+	pq_sendint16(&buf, 0);		/* attphysnum */
 	pq_sendint32(&buf, TEXTOID);	/* type oid */
 	pq_sendint16(&buf, -1);		/* typlen */
 	pq_sendint32(&buf, 0);		/* typmod */
@@ -611,7 +611,7 @@ SendTimeLineHistory(TimeLineHistoryCmd *cmd)
 	/* second field */
 	pq_sendstring(&buf, "content"); /* col name */
 	pq_sendint32(&buf, 0);		/* table oid */
-	pq_sendint16(&buf, 0);		/* attnum */
+	pq_sendint16(&buf, 0);		/* attphysnum */
 	pq_sendint32(&buf, TEXTOID);	/* type oid */
 	pq_sendint16(&buf, -1);		/* typlen */
 	pq_sendint32(&buf, 0);		/* typmod */
